## org.apache.commons.math.optimization.general
Enum ConjugateGradientFormula

    java.lang.Object
      java.lang.Enum<ConjugateGradientFormula>
          org.apache.commons.math.optimization.general.ConjugateGradientFormula

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable<ConjugateGradientFormula>

    public enum ConjugateGradientFormula

extends java.lang.Enum<ConjugateGradientFormula>

Available choices of update formulas for the β parameter in `NonLinearConjugateGradientOptimizer`.

The β parameter is used to compute the successive conjugate search directions. For non-linear conjugate gradients, there are two formulas to compute β:

- Fletcher-Reeves formula
- Polak-Ribière formula

On the one hand, the Fletcher-Reeves formula is guaranteed to converge if the start point is close enough of the optimum whether the Polak-Ribière formula may not converge in rare cases. On the other hand, the Polak-Ribière formula is often faster when it does converge. Polak-Ribière is often used.

Since:
  2.0
Version:
  $Revision: 758059 $ $Date: 2009-03-24 18:16:21 -0400 (Tue, 24 Mar 2009) $
See Also:
  `NonLinearConjugateGradientOptimizer`

Enum Constant Summary
`FLETCHER_REEVES` Fletcher-Reeves formula.
`POLAK_RIBIERE` Polak-Ribière formula.

Method Summary
`static ConjugateGradientFormula` `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
`static ConjugateGradientFormula[]` `values()` Returns an array containing the constants of this enum type, in the order they are declared.

Methods inherited from class java.lang.Enum
`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Enum Constant Detail

### FLETCHER_REEVES

    public static final ConjugateGradientFormula FLETCHER_REEVES

  Fletcher-Reeves formula.

### POLAK_RIBIERE

    public static final ConjugateGradientFormula POLAK_RIBIERE

  Polak-Ribière formula.

Method Detail

### values

    public static ConjugateGradientFormula[] values()

  Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

      for (ConjugateGradientFormula c : ConjugateGradientFormula.values())
          System.out.println(c);

  Returns:
    an array containing the constants of this enum type, in the order they are declared

### valueOf

    public static ConjugateGradientFormula valueOf(java.lang.String name)

  Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

  Parameters:
    `name` - the name of the enum constant to be returned.
  Returns:
    the enum constant with the specified name
  Throws:
    `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
    `java.lang.NullPointerException` - if the argument is null

Copyright (c) 2003-2011 Apache Software Foundation